---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Signal.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Signal.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_SIGNAL_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_SIGNAL_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;TGUI/Global.hpp&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;TGUI/Callback.hpp&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;cassert&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;{</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">class </span>Widget;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">class </span>ChildWindow;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... Types&gt;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">struct </span>TypeSet;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">namespace </span>priv</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">extern</span> TGUI_API std::deque&lt;const void*&gt; data;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        std::string convertTypeToString();</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">template</span> &lt;&gt; <span class="keyword">inline</span> std::string convertTypeToString&lt;int&gt;() { <span class="keywordflow">return</span> <span class="stringliteral">&quot;int&quot;</span>; }</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">template</span> &lt;&gt; <span class="keyword">inline</span> std::string convertTypeToString&lt;sf::Vector2f&gt;() { <span class="keywordflow">return</span> <span class="stringliteral">&quot;sf::Vector2f&quot;</span>; }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keyword">template</span> &lt;&gt; <span class="keyword">inline</span> std::string convertTypeToString&lt;sf::String&gt;() { <span class="keywordflow">return</span> <span class="stringliteral">&quot;sf::String&quot;</span>; }</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keyword">template</span> &lt;&gt; <span class="keyword">inline</span> std::string convertTypeToString&lt;std::vector&lt;sf::String&gt;&gt;() { <span class="keywordflow">return</span> <span class="stringliteral">&quot;std::vector&lt;sf::String&gt;&quot;</span>; }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">template</span> &lt;&gt; <span class="keyword">inline</span> std::string convertTypeToString&lt;std::shared_ptr&lt;ChildWindow&gt;&gt;() { <span class="keywordflow">return</span> <span class="stringliteral">&quot;std::shared_ptr&lt;ChildWindow&gt;&quot;</span>; }</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... Types&gt;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">struct </span>extractTypes</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        {</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::vector&lt;std::string&gt;&gt; <span class="keyword">get</span>() { <span class="keywordflow">return</span> {}; }</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::string&gt; getRow() { <span class="keywordflow">return</span> {}; }</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        };</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Type&gt;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">struct </span>extractTypes&lt;Type&gt;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        {</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::vector&lt;std::string&gt;&gt; <span class="keyword">get</span>() { <span class="keywordflow">return</span> {{convertTypeToString&lt;Type&gt;()}}; }</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::string&gt; getRow() { <span class="keywordflow">return</span> {convertTypeToString&lt;Type&gt;()}; }</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        };</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Type, <span class="keyword">typename</span>... OtherTypes&gt;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keyword">struct </span>extractTypes&lt;Type, OtherTypes...&gt;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        {</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::vector&lt;std::string&gt;&gt; <span class="keyword">get</span>()</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            {</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                <span class="keyword">auto</span> types = extractTypes&lt;OtherTypes...&gt;::get();</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                types.insert(types.begin(), {convertTypeToString&lt;Type&gt;()});</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;                <span class="keywordflow">return</span> types;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::string&gt; getRow()</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            {</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;                <span class="keyword">auto</span> types = extractTypes&lt;OtherTypes...&gt;::getRow();</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;                types.insert(types.begin(), convertTypeToString&lt;Type&gt;());</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                <span class="keywordflow">return</span> types;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        };</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... T&gt;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">struct </span>extractTypes&lt;TypeSet&lt;T...&gt;&gt;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        {</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::vector&lt;std::string&gt;&gt; <span class="keyword">get</span>() { <span class="keywordflow">return</span> {extractTypes&lt;T...&gt;::getRow()}; }</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        };</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... T, <span class="keyword">typename</span>... U&gt;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keyword">struct </span>extractTypes&lt;TypeSet&lt;T...&gt;, U...&gt;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        {</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="keyword">static</span> std::vector&lt;std::vector&lt;std::string&gt;&gt; <span class="keyword">get</span>()</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            {</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                <span class="keyword">auto</span> types = {extractTypes&lt;T...&gt;::getRow()};</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                types.insert(types.end(), extractTypes&lt;U...&gt;::get());</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                <span class="keywordflow">return</span> types;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            }</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        };</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span> TypeA, <span class="keyword">typename</span> TypeB, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="keyword">struct </span>isConvertible;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... TypesA, <span class="keyword">typename</span>... TypesB, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keyword">struct </span>isConvertible&lt;Func, TypeSet&lt;TypesA...&gt;, TypeSet&lt;TypesB...&gt;, Args...&gt;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        {</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="keyword">using</span> type = <span class="keyword">typename</span> std::conditional&lt;std::is_convertible&lt;Func, std::function&lt;void(Args..., TypesA...)&gt;&gt;::value, TypeSet&lt;TypesA...&gt;, TypeSet&lt;TypesB...&gt;&gt;::type;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        };</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Type, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="keyword">struct </span>isConvertible&lt;Func, TypeSet&lt;&gt;, TypeSet&lt;Type...&gt;, Args...&gt;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        {</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="keyword">using</span> type = <span class="keyword">typename</span> std::conditional&lt;std::is_convertible&lt;Func, std::function&lt;void(Args...)&gt;&gt;::value || std::is_convertible&lt;Func, std::function&lt;void(Args...)&gt;&gt;::value, TypeSet&lt;&gt;, TypeSet&lt;Type...&gt;&gt;::type;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        };</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Type&gt;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keyword">const</span> Type&amp; dereference(<span class="keyword">const</span> <span class="keywordtype">void</span>* obj)</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">static_cast&lt;</span><span class="keyword">const </span>Type*<span class="keyword">&gt;</span>(obj);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        }</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="comment">// Ignore warning &quot;C4800: &#39;const int&#39;: forcing value to bool &#39;true&#39; or &#39;false&#39; (performance warning)&quot; in Visual Studio</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="preprocessor">#if defined SFML_SYSTEM_WINDOWS &amp;&amp; defined _MSC_VER</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">    #pragma warning(push)</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">    #pragma warning(disable : 4800)</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... T&gt;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keyword">struct </span>connector;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keyword">struct </span>connector&lt;TypeSet&lt;&gt;, Func, Args...&gt;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        {</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            <span class="keyword">static</span> std::function&lt;void()&gt; connect(Func func, std::size_t, Args... args)</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            {</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                <span class="keywordflow">return</span> std::bind(func, args...);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            }</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        };</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args, <span class="keyword">typename</span> Type&gt;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keyword">struct </span>connector&lt;TypeSet&lt;Type&gt;, Func, Args...&gt;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        {</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <span class="keyword">static</span> std::function&lt;void()&gt; connect(Func func, std::size_t argPos, Args... args)</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            {</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                <span class="keywordflow">return</span> std::bind(func, args..., std::bind(dereference&lt;Type&gt;, std::cref(data[argPos])));</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            }</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        };</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args, <span class="keyword">typename</span> TypeA, <span class="keyword">typename</span> TypeB&gt;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keyword">struct </span>connector&lt;TypeSet&lt;TypeA, TypeB&gt;, Func, Args...&gt;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        {</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            <span class="keyword">static</span> std::function&lt;void()&gt; connect(Func func, std::size_t argPos, Args... args)</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            {</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                <span class="keywordflow">return</span> std::bind(func, args...,</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                                 std::bind(dereference&lt;TypeA&gt;, std::cref(data[argPos])),</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                                 std::bind(dereference&lt;TypeB&gt;, std::cref(data[argPos+1])));</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        };</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;<span class="preprocessor">#if defined SFML_SYSTEM_WINDOWS &amp;&amp; defined _MSC_VER</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="preprocessor">    #pragma warning(pop)</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Arg, <span class="keyword">typename</span> = <span class="keywordtype">void</span>&gt;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="keyword">struct </span>bindRemover</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        {</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            <span class="keyword">static</span> Arg <span class="keyword">remove</span>(Arg arg)</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            {</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                <span class="keywordflow">return</span> arg;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            }</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        };</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Arg&gt;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="keyword">struct </span>bindRemover&lt;Arg, typename std::enable_if&lt;std::is_bind_expression&lt;Arg&gt;::value&gt;::type&gt;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        {</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            <span class="keyword">static</span> <span class="keyword">auto</span> <span class="keyword">remove</span>(Arg arg) -&gt; decltype(arg())</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            {</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;                <span class="keywordflow">return</span> arg();</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            }</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        };</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        <span class="keyword">struct </span>isFunctionConvertible</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        {</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="keyword">using</span> type = <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;&gt;,</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;                            <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;int&gt;,</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;                                <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;sf::Vector2f&gt;,</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;                                    <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;sf::String&gt;,</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;                                        <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;std::vector&lt;sf::String&gt;&gt;,</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                                            <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;std::shared_ptr&lt;ChildWindow&gt;&gt;,</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                                                <span class="keyword">typename</span> isConvertible&lt;Func, TypeSet&lt;sf::String, sf::String&gt;,</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                                                    TypeSet&lt;void&gt;,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                                                    Args...&gt;::type,</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                                                Args...&gt;::type,</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                                            Args...&gt;::type,</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                                        Args...&gt;::type,</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                                    Args...&gt;::type,</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                                Args...&gt;::type,</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                            Args...&gt;::type;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        };</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    }</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="comment">// Stores the actual callback functions and checks if their parameters are valid</span></div><div class="line"><a name="l00238"></a><span class="lineno"><a class="line" href="classtgui_1_1Signal.html">  238</a></span>&#160;<span class="comment"></span>    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Signal.html">Signal</a></div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    {</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <a class="code" href="classtgui_1_1Signal.html">Signal</a>(std::vector&lt;std::vector&lt;std::string&gt;&gt;&amp;&amp; types);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keywordtype">void</span> connect(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>, Func func, Args... args)</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        {</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            <span class="keyword">using</span> type = <span class="keyword">typename</span> priv::isFunctionConvertible&lt;Func, decltype(priv::bindRemover&lt;Args&gt;::remove(args))...&gt;::type;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            static_assert(!std::is_same&lt;type, TypeSet&lt;void&gt;&gt;::value, <span class="stringliteral">&quot;Parameters passed to the connect function are wrong!&quot;</span>);</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            <span class="keyword">auto</span> argPos = checkCompatibleParameterType&lt;type&gt;();</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            m_functions[id] = priv::connector&lt;type, Func, Args...&gt;::connect(func, argPos, args...);</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        }</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keywordtype">void</span> connectEx(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>, Func func, Args... args)</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        {</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            m_functionsEx[id] = std::bind(func, args..., std::placeholders::_1);</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        }</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keywordtype">bool</span> disconnect(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        <span class="keywordtype">void</span> disconnectAll();</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        <span class="keywordtype">bool</span> isEmpty() <span class="keyword">const</span>;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        <span class="keywordtype">void</span> operator()(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="keywordtype">void</span> operator()(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> count, <span class="keyword">const</span> T&amp; value, Args... args)</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        {</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            priv::data[count] = <span class="keyword">static_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">void</span>*<span class="keyword">&gt;</span>(&amp;value);</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            (*this)(count+1, args...);</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        }</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Type&gt;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        std::size_t checkCompatibleParameterType()</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        {</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            <span class="keywordflow">if</span> (std::is_same&lt;Type, TypeSet&lt;&gt;&gt;::value)</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;                <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            <span class="keyword">auto</span> acceptedType = priv::extractTypes&lt;Type&gt;::get();</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            assert(acceptedType.size() == 1);</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            std::size_t count = 0;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            <span class="keywordflow">for</span> (std::size_t i = 0; i &lt; m_allowedTypes.size(); ++i)</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            {</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;                <span class="keywordflow">if</span> (acceptedType[0] == m_allowedTypes[i])</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;                    <span class="keywordflow">return</span> count;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;                count += m_allowedTypes[i].size();</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            }</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{<span class="stringliteral">&quot;Failed to bind parameter to callback function. Parameter is of wrong type.&quot;</span>};</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        }</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        std::map&lt;unsigned int, std::function&lt;void()&gt;&gt; m_functions;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        std::map&lt;unsigned int, std::function&lt;void(const Callback&amp;)&gt;&gt; m_functionsEx;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        std::vector&lt;std::vector&lt;std::string&gt;&gt; m_allowedTypes;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>; <span class="comment">// Only needed for m_functionsEx</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    };</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno"><a class="line" href="classtgui_1_1SignalWidgetBase.html">  312</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a></div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    {</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>&amp; copy);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>&amp; right);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00354"></a><span class="lineno"><a class="line" href="classtgui_1_1SignalWidgetBase.html#a3a310a997fdfb38e38688a6086832a95">  354</a></span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classtgui_1_1SignalWidgetBase.html#a3a310a997fdfb38e38688a6086832a95">connect</a>(<span class="keyword">const</span> std::string&amp; signalNames, Func func, Args... args)</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        {</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;            <span class="keyword">auto</span> signalNameList = extractSignalNames(signalNames);</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;            <span class="keywordflow">if</span> (signalNameList.empty())</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;                <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{<span class="stringliteral">&quot;connect function called with empty string&quot;</span>};</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;            <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; signalName : signalNameList)</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;            {</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;                <span class="keywordflow">if</span> (m_signals.find(toLower(signalName)) != m_signals.end())</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;                {</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;                    <span class="keywordflow">try</span> {</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;                        m_signals[toLower(signalName)]-&gt;connect(m_lastId, func, args...);</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;                        m_lastId++;</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;                    }</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;                    <span class="keywordflow">catch</span> (<span class="keyword">const</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>&amp; e) {</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;                        <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{e.what() + (<span class="stringliteral">&quot; The parameters are not valid for the &#39;&quot;</span> + signalName + <span class="stringliteral">&quot;&#39; signal.&quot;</span>)};</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;                    }</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;                }</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;                {</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;                    <span class="keywordflow">if</span> (toLower(signalName) != <span class="stringliteral">&quot;all&quot;</span>)</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;                        <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{<span class="stringliteral">&quot;Cannot connect to unknown signal &#39;&quot;</span> + signalName + <span class="stringliteral">&quot;&#39;.&quot;</span>};</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;                    <span class="keywordflow">else</span></div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;                    {</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;                        assert(!m_signals.empty());</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;                        <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; signal : m_signals)</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;                        {</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;                            <span class="keywordflow">try</span> {</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;                                signal.second-&gt;connect(m_lastId, func, args...);</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;                                m_lastId++;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;                            }</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;                            <span class="keywordflow">catch</span> (<span class="keyword">const</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>&amp; e) {</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;                                <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{e.what() + (<span class="stringliteral">&quot; The parameters are not valid for the &#39;&quot;</span> + signalName + <span class="stringliteral">&quot;&#39; signal.&quot;</span>)};</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;                            }</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;                        }</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;                    }</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;                }</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;            }</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;            <span class="keywordflow">return</span> m_lastId - 1;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        }</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Func, <span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00411"></a><span class="lineno"><a class="line" href="classtgui_1_1SignalWidgetBase.html#a9b0187cd74457415140526ba788504d1">  411</a></span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classtgui_1_1SignalWidgetBase.html#a9b0187cd74457415140526ba788504d1">connectEx</a>(<span class="keyword">const</span> std::string&amp; signalName, Func func, Args... args)</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        {</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;            <span class="keyword">auto</span> signalNameList = extractSignalNames(signalName);</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;            <span class="keywordflow">if</span> (signalNameList.empty())</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;                <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{<span class="stringliteral">&quot;connect function called with empty string&quot;</span>};</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;            <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; name : signalNameList)</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;            {</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;                <span class="keywordflow">if</span> (m_signals.find(toLower(name)) != m_signals.end())</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;                {</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;                    <span class="keywordflow">try</span> {</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;                        m_signals[toLower(name)]-&gt;connectEx(m_lastId, func, args...);</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;                        m_lastId++;</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;                    }</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;                    <span class="keywordflow">catch</span> (<span class="keyword">const</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>&amp; e) {</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;                        <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{e.what() + (<span class="stringliteral">&quot; since it is not valid for the &#39;&quot;</span> + name + <span class="stringliteral">&quot;&#39; signal.&quot;</span>)};</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;                    }</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;                }</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;                <span class="keywordflow">else</span> <span class="comment">// Signal name does not exist</span></div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;                {</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;                    <span class="keywordflow">if</span> (toLower(name) != <span class="stringliteral">&quot;all&quot;</span>)</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;                        <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{<span class="stringliteral">&quot;Cannot connect to unknown signal &#39;&quot;</span> + name + <span class="stringliteral">&quot;&#39;.&quot;</span>};</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;                    <span class="keywordflow">else</span></div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;                    {</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;                        assert(!m_signals.empty());</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;                        <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; signal : m_signals)</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;                        {</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;                            <span class="keywordflow">try</span> {</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;                                signal.second-&gt;connectEx(m_lastId, func, args...);</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;                                m_lastId++;</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;                            }</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;                            <span class="keywordflow">catch</span> (<span class="keyword">const</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>&amp; e) {</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;                                <span class="keywordflow">throw</span> <a class="code" href="classtgui_1_1Exception.html">Exception</a>{e.what() + (<span class="stringliteral">&quot; since it is not valid for the &#39;&quot;</span> + name + <span class="stringliteral">&quot;&#39; signal.&quot;</span>)};</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;                            }</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;                        }</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;                    }</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;                }</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;            }</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;            <span class="keywordflow">return</span> m_lastId - 1;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;        }</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;        <span class="keywordtype">void</span> disconnect(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        <span class="keywordtype">void</span> disconnectAll(<span class="keyword">const</span> std::string&amp; signalName);</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;        <span class="keywordtype">void</span> disconnectAll();</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;        <span class="comment">// Add a new signal that people can bind.</span></div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;<span class="comment"></span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... T&gt;</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;        <span class="keywordtype">void</span> addSignal(std::string&amp;&amp; name)</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        {</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;            assert(m_signals[toLower(name)] == <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;            m_signals[toLower(name)] = std::make_shared&lt;Signal&gt;(priv::extractTypes&lt;T...&gt;::get());</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        }</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        <span class="comment">// Check if some signal handler has been bound to the signal.</span></div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;<span class="comment"></span>        <span class="keywordtype">bool</span> isSignalBound(std::string&amp;&amp; name);</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        <span class="comment">// Send a signal to all signal handlers that are connected with this signal.</span></div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;<span class="comment"></span>        <span class="keyword">template</span> &lt;<span class="keyword">typename</span>... Args&gt;</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;        <span class="keywordtype">void</span> sendSignal(std::string&amp;&amp; name, Args... args)</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;        {</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;            assert(m_signals[toLower(name)] != <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;            <span class="keyword">auto</span>&amp; signal = *m_signals[toLower(name)];</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;            <span class="keywordflow">if</span> (signal.m_functionsEx.empty())</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;            {</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;                <span class="keywordflow">if</span> (!signal.isEmpty())</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;                    signal(0, args...);</div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;            }</div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;            <span class="keywordflow">else</span> <span class="comment">// Legacy functions are used</span></div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;            {</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;                <span class="comment">// Copy signal to avoid problems with lifetime when signal handler destroys this object</span></div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;                <a class="code" href="classtgui_1_1Signal.html">Signal</a> signalCopy = signal;</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;                m_callback.trigger = name;</div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;                <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; <span class="keyword">function</span> : signalCopy.m_functionsEx)</div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;                    <span class="keyword">function</span>.second(m_callback);</div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;                <span class="keywordflow">if</span> (!signalCopy.isEmpty())</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;                    signalCopy(0, args...);</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;            }</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;        }</div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;        std::vector&lt;std::string&gt; extractSignalNames(std::string input);</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;        std::map&lt;std::string, std::shared_ptr&lt;Signal&gt;&gt; m_signals;</div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;</div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_lastId;</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;        <a class="code" href="structtgui_1_1Callback.html">Callback</a> m_callback;</div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;</div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;    };</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;</div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;}</div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;</div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;</div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;<span class="preprocessor">#endif // TGUI_SIGNAL_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="classtgui_1_1SignalWidgetBase_html_a3a310a997fdfb38e38688a6086832a95"><div class="ttname"><a href="classtgui_1_1SignalWidgetBase.html#a3a310a997fdfb38e38688a6086832a95">tgui::SignalWidgetBase::connect</a></div><div class="ttdeci">unsigned int connect(const std::string &amp;signalNames, Func func, Args...args)</div><div class="ttdoc">Connects a signal handler function to one or more signals. </div><div class="ttdef"><b>Definition:</b> Signal.hpp:354</div></div>
<div class="ttc" id="structtgui_1_1Callback_html"><div class="ttname"><a href="structtgui_1_1Callback.html">tgui::Callback</a></div><div class="ttdef"><b>Definition:</b> Callback.hpp:44</div></div>
<div class="ttc" id="classtgui_1_1Exception_html"><div class="ttname"><a href="classtgui_1_1Exception.html">tgui::Exception</a></div><div class="ttdef"><b>Definition:</b> Exception.hpp:44</div></div>
<div class="ttc" id="classtgui_1_1SignalWidgetBase_html"><div class="ttname"><a href="classtgui_1_1SignalWidgetBase.html">tgui::SignalWidgetBase</a></div><div class="ttdoc">Base class for widgets to enable signal handling. </div><div class="ttdef"><b>Definition:</b> Signal.hpp:312</div></div>
<div class="ttc" id="classtgui_1_1Signal_html"><div class="ttname"><a href="classtgui_1_1Signal.html">tgui::Signal</a></div><div class="ttdef"><b>Definition:</b> Signal.hpp:238</div></div>
<div class="ttc" id="classtgui_1_1SignalWidgetBase_html_a9b0187cd74457415140526ba788504d1"><div class="ttname"><a href="classtgui_1_1SignalWidgetBase.html#a9b0187cd74457415140526ba788504d1">tgui::SignalWidgetBase::connectEx</a></div><div class="ttdeci">unsigned int connectEx(const std::string &amp;signalName, Func func, Args...args)</div><div class="ttdoc">Connects a signal handler function to one or more signals. </div><div class="ttdef"><b>Definition:</b> Signal.hpp:411</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:41 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
